Package: gaawr2
Title: Genetic Association Analysis
Version: 0.0.8
Date: 2026-6-17
Authors@R: c(person("Jing Hua", "Zhao", , role = c("aut", "cre"),
                  email = "jinghuazhao@hotmail.com",
                  comment = c(ORCID = "https://orcid.org/0000-0002-1463-5870", ORCID = "0000-0003-4930-3582")),
           person("Benjamin", "Altmann", role = "ctb"),
           person("Brian", "Ripley", role = "ctb")
           )
Maintainer: Jing Hua Zhao <jinghuazhao@hotmail.com>
Description: This is a companion to Henry-Stewart talk by Zhao (2026, <doi:10.69645/FRFQ9519>),
 which gathers information, metadata and scripts to showcase modern genetic analysis -- ranging from testing
 of polymorphic variant(s) for Hardy-Weinberg equilibrium, association with traits using genetic and statistical
 models, Bayesian implementation, power calculation in study design, and genetic annotation. It also covers
 R integration with the Linux environment, GitHub, package creation and web applications. The earlier version
 by Zhao (2009, <doi:10.69645/DCRY5578>) provides a brief introduction to these topics.
License: MIT + file LICENSE
URL: https://jinghuazhao.github.io/gaawr2/,
        https://github.com/jinghuazhao/gaawr2
BugReports: https://github.com/jinghuazhao/gaawr2/issues
Encoding: UTF-8
Depends: R (>= 3.5.0)
Imports: dplyr, gap, gap.datasets, ggplot2, survival, Rdpack
RdMacros: Rdpack
VignetteBuilder: knitr
LazyData: Yes
LazyLoad: Yes
LazyDataCompression: xz
Suggests: BLR, BGLR, biomaRt, bookdown, Cairo, EnsDb.Hsapiens.v75,
        ensembldb, GMMAT, HardyWeinberg, haplo.stats, htmltools, httr,
        httpuv, jsonlite, kableExtra, knitr, MCMCglmm, plumber,
        powerEQTL, R2jags, regress, Rsamtools, SNPassoc, testthat,
        tidyr
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-06-17 17:10:58 UTC; jhz22
Author: Jing Hua Zhao [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1463-5870>, ORCID:
    <https://orcid.org/0000-0003-4930-3582>),
  Benjamin Altmann [ctb],
  Brian Ripley [ctb]
Repository: CRAN
Date/Publication: 2026-06-17 18:00:11 UTC
Built: R 4.6.0; ; 2026-06-17 20:07:13 UTC; unix

---
output: github_document
---



<img src="man/figures/logo.svg" style="float: right;" height="240" width="240" alt="gaawr2 website" />

## Genetic Association Analysis



<!-- badges: start -->
[![pages-build-deployment](https://github.com/jinghuazhao/gaawr2/actions/workflows/pages/pages-build-deployment/badge.svg)](https://github.com/jinghuazhao/gaawr2/actions/workflows/pages/pages-build-deployment)
[![R-CMD-check](https://github.com/jinghuazhao/gaawr2/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/jinghuazhao/gaawr2/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->


This is a companion to Henry-Stewart talk by Zhao (2026, <[doi:10.69645/FRFQ9519](https://doi.org/doi:10.69645/FRFQ9519)>), which gathers information, metadata and scripts to showcase modern genetic analysis -- ranging from testing of polymorphic variant(s) for Hardy-Weinberg equilibrium, association with traits using genetic and statistical models, Bayesian implementation, power calculation in study design, and genetic annotation. It also covers R integration with the Linux environment, GitHub, package creation and web applications. The earlier version by Zhao (2009, <[doi:10.69645/DCRY5578](https://doi.org/doi:10.69645/DCRY5578)>) provides a brief introduction to these topics.

## Installation

The latest version of **gaawr2** can be installed as usual:

### 1. Install from R

```r
# CRAN
install.packages("gaawr2")

# GitHub
if (!requireNamespace("remotes", quietly = TRUE)) install.packages("remotes")
remotes::install_github("jinghuazhao/gaawr2")
```

### 2. Install from GitHub repository

```bash
git clone https://github.com/jinghuazhao/gaawr2
R CMD INSTALL gaawr2
```

Dependencies are detailed in the DECRIPTION file of the package at GitHub.

## A summary of functions

This can be seen from R with

```r
library(help=gaawr2)
```

or

```r
library(gaawr2)
?gaawr2
```

# A summary of files

Filename   | Description
-----------|--------------------------------
biomaRt.R  | biomaRt query
cran.sh*   | CRAN package extraction 
docs.sh*   | GitHub updates
ens.R      | Ensembl database
gaawr2.R   | R/**gaawr2** creation
github.sh* | GitHub/**gaawr2** creation
GMMAT.R    | **GMMAT** script
h2.jags.R  | h2.jags documentation example
haplo.stats.R    | **haplo.stats** script
HardyWeinberg.R  | **HardyWeinberg** scrip
hello.R    | "Hello, world!"
httr.R     | **httr** script
lz.R       | **locuszoomr** script
ontologyIndex.R  | **ontologyIndex** script
OpenTargets.R    | OpenTarget query
pkgdown.sh*| **pkgdown** script
powerEQTL.R| **powerEQTL** script
README.md  | This file
rentrez.R  | **entrez** query
SNPassoc.R | **SNPassoc** script
tabix.sh*  | **tabix** script

Given the limited allowance for computing time for CRAN checking, scripts here are largely perferable to those in the package vignette, 
[`gaawr2`]. Owing to CRAN poly, R scripts are revised to be functions.

Additionally,

- `cran.sh` makes a copy of the latest repository but drops files not needed by CRAN.
- `hwe_ternary_plotly.py` is a Python script using plotly for the HWE ternary plot whose top vertex (the “a‑axis”) represents A1A2, the left vertex (the “b‑axis”) A1A2, and the right vertex (the “c‑axis”) A2A2.

run_haplo.stats <- function()
{
  library(SNPassoc)
  library(dplyr)
  par.default <- par()
  data(asthma, package = "SNPassoc")
  asthma.snps <- SNPassoc::setupSNP(data=asthma, colSNPs=grep("^rs", colnames(asthma)), sep="")
  asthma.snps <- setupSNP(data=asthma, colSNPs=grep("^rs", colnames(asthma)), sep="") %>%
                 dplyr::rename(cc=casecontrol)
  library(haplo.stats)
  snpsH <- c("rs714588", "rs1023555",  "rs898070")
  genoH <- SNPassoc::make.geno(asthma.snps, snpsH)
  em <- haplo.stats::haplo.em(genoH, locus.label = snpsH, miss.val = c(0, NA))
  em
  knitr::kable(cbind(em$haplotype,em$hap.prob),caption="Haplotypes of rs714588, rs1023555, rs898070")

  mod <- haplo.stats::haplo.glm(cc ~ genoH, data=asthma.snps,
                                family="binomial",
                                locus.label=snpsH,
                                allele.lev=attributes(genoH)$unique.alleles,
                                control = haplo.stats::haplo.glm.control(haplo.freq.min=0.05))
  mod
  SNPassoc::intervals(mod)
  snpsH2 <- labels(asthma.snps)[6:15]
  genoH2 <- make.geno(asthma.snps, snpsH2)
  haplo.score <- list()
  for (i in 1:4) haplo.score[[i]] <- haplo.stats::haplo.score.slide(asthma.snps$cc, genoH2,
                                           trait.type="binomial",
                                           n.slide=i+3,
                                           simulate=TRUE,
                                           sim.control=haplo.stats::score.sim.control(min.sim=100,
                                           max.sim=200)) 
  par(mfrow=c(2,2))
  for (i in 1:4) {
      plot(haplo.score[[i]])
      title(paste("Sliding Window=", i+3, sep=""))
  }
  snpsH3 <- snpsH2[4:7]
  genoH3 <- make.geno(asthma.snps, snpsH3)
  mod <- haplo.stats::haplo.glm(cc~genoH3, data=asthma.snps,
               family="binomial",
               locus.label=snpsH3,
               allele.lev=attributes(genoH3)$unique.alleles,
               control = haplo.stats::haplo.glm.control(haplo.freq.min=0.05))
  mod
  SNPassoc::intervals(mod)
  mod.adj.ref <- glm(cc ~ smoke, data=asthma.snps, family="binomial")
  mod.adj <- haplo.glm(cc ~ genoH3 + smoke, data=asthma.snps,
                       family="binomial",
                       locus.label=snpsH3,
                       allele.lev=attributes(genoH3)$unique.alleles,
                       control = haplo.stats::haplo.glm.control(haplo.freq.min=0.05))
  mod.adj
  lrt.adj <- mod.adj.ref$deviance - mod.adj$deviance
  pchisq(lrt.adj, mod.adj$lrt$df, lower=FALSE)
  par(par.default)
}

run_SNPassoc <- function()
{
  options.default <- options()
  options(width=200,digits=2)
  data(asthma, package = "SNPassoc")
  str(asthma, list.len=8)
  knitr::kable(asthma[1:3,1:8],caption="First three records & two SNPs")
  snpCols <- colnames(asthma)[6+(1:2)]
  snps <- SNPassoc::setupSNP(data=asthma[snpCols], colSNPs=1:length(snpCols), sep="")
  head(snps)
  summary(snps, print=FALSE)
  lapply(snps, head)
  lapply(snps, summary)
  SNPassoc::tableHWE(snps)

  asthma.snps <- asthma %>%
                 dplyr::rename(cc=casecontrol) %>%
                 SNPassoc::setupSNP(colSNPs=(6+1):ncol(.), sep="")
# Model 1: Simple SNP association with BMI
  SNPassoc::association(bmi ~ rs4490198, data = asthma.snps)

# Model 2: SNP association with case-control status
  SNPassoc::association(cc ~ rs4490198, data = asthma.snps)

# Model 3: SNP association with covariates (country and smoke)
  SNPassoc::association(cc ~ rs4490198 + country + smoke, data = asthma.snps)

# Model 4: SNP association with stratification by gender
  SNPassoc::association(cc ~ rs4490198 + survival::strata(gender), data = asthma.snps)

# Model 5: SNP association with subset (only Spain)
  SNPassoc::association(cc ~ rs4490198, data = asthma.snps, subset = country == "Spain")

# Model 6: Interaction between SNP (dominant model) and smoking
  SNPassoc::association(cc ~ SNPassoc::dominant(rs4490198) * factor(smoke), data = asthma.snps)

# Model 7: Interaction between two SNPs (dominant model for rs4490198)
  SNPassoc::association(cc ~ rs4490198 * factor(rs11123242), data = asthma.snps, model.interaction = "dominant")

  assoc <- SNPassoc::WGassociation(cc, data=asthma.snps, mc.cores=5)
  assoc %>%
  as.data.frame() %>%
  dplyr::select(-comments) %>%
  knitr::kable(caption="SNP association")
  assoc.adj <- SNPassoc::WGassociation(cc ~ country + smoke, asthma.snps, mc.cores=5)
  assoc.adj %>%
  as.data.frame() %>%
  dplyr::select(-comments) %>%
  knitr::kable(caption="with adjustment for contountry & smoking")
  assoc.maxstat <- SNPassoc::maxstat(asthma.snps, cc)
  knitr::kable(t(assoc.maxstat[,]),caption="Max stat association statistics")
  options(options.default)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----gaawr2_incl, echo=FALSE, results='asis'----------------------------------
htmltools::tags$iframe(
  src = "https://jinghuazhao.github.io/R/vignettes/gaawr2.html",
  width = "100%",
  style = "height:100vh; border:none;"
)

use_ensembl <- function()
{
  require(dplyr)
  require(EnsDb.Hsapiens.v75)
  ensembldb::metadata(EnsDb.Hsapiens.v75)
  ensembldb::keytypes(EnsDb.Hsapiens.v75)
  exon_info <- ensembldb::exons(EnsDb.Hsapiens.v75)
  gene_info <- ensembldb::genes(EnsDb.Hsapiens.v75)
  transcript_info <- ensembldb::transcripts(EnsDb.Hsapiens.v75)
  colnames(S4Vectors::mcols(gene_info))
  colnames(S4Vectors::mcols(transcript_info))
  overlaps <- IRanges::findOverlaps(transcript_info, gene_info)
  overlapping_transcripts <- transcript_info[queryHits(overlaps)]
  overlapping_genes <- gene_info[subjectHits(overlaps)]
  overlap_data <- data.frame(
    transcript_id = mcols(overlapping_transcripts)$tx_id,
    gene_id = S4Vectors::mcols(overlapping_genes)$gene_id,
    gene_name = S4Vectors::mcols(overlapping_genes)$gene_name,
    start = pmax(start(overlapping_transcripts), start(overlapping_genes)),
    end = pmin(end(overlapping_transcripts), end(overlapping_genes))
  )
  gene_symbols <- c("BRCA1", "TP53")
  gene_data <- subset(overlap_data,gene_name%in%gene_symbols,select=-c(gene_id,gene_name))
  cols <- c("UNIPROTID","PROTEINID","GENEID","GENENAME","SEQNAME","TXID")
  info <- ensembldb::select(EnsDb.Hsapiens.v75, keys = gene_symbols, 
                            columns = cols, keytype = "SYMBOL") |>
          subset(!is.na(UNIPROTID)) |>
          dplyr::left_join(gene_data,by=c('TXID'='transcript_id'))
# more focused on genes
  library(org.Hs.eg.db)
  keytypes(org.Hs.eg.db)
  uniprot_ids <- ensembldb::select(org.Hs.eg.db, keys = gene_symbols, columns = "UNIPROT", keytype = "SYMBOL")

# ensembldb::keytypes(EnsDb.Hsapiens.v75)
# [1] "ENTREZID"  "EXONID"  "GENEBIOTYPE" "GENEID" "GENENAME"  "PROTDOMID" "PROTEINDOMAINID" "PROTEINDOMAINSOURCE"
# [9] "PROTEINID" "SEQNAME" "SEQSTRAND"   "SYMBOL" "TXBIOTYPE" "TXID"      "TXNAME"          "UNIPROTID"
# colnames(S4Vectors::mcols(gene_info))
# [1] "gene_id"          "gene_name"        "gene_biotype"     "seq_coord_system" "symbol"           "entrezid"
# colnames(S4Vectors::mcols(transcript_info))
# [1] "tx_id"            "tx_biotype"       "tx_cds_seq_start" "tx_cds_seq_end"   "gene_id"          "tx_name"
# keytypes(org.Hs.eg.db)
# uniprot_ids <- ensembldb::select(org.Hs.eg.db, keys = gene_symbols, columns = "UNIPROT", keytype = "SYMBOL")
# dim(uniprot_ids)
}

if (!requireNamespace("httr", quietly = TRUE)) install.packages("bibtex")
if (!requireNamespace("httr", quietly = TRUE)) install.packages("httr")
if (!requireNamespace("XML", quietly = TRUE)) install.packages("XML")

library(bibtex)
library(httr)
library(XML)

# to check URL status
check_url_status <- function(url) {
  response <- tryCatch(httr::HEAD(url), error = function(e) NULL)
  if (!is.null(response) && httr::status_code(response) == 200) {
    return(TRUE)
  } else {
    return(FALSE)
  }
}

# to check URL status in a BibTeX file
check_bib_url_status <- function(bib_file) {
  bib <- bibtex::read.bib(bib_file)
  for (i in seq_along(bib)) {
    if ("url" %in% names(bib[[i]])) {
      url <- bib[[i]]$url
      if (!check_url_status(url)) {
        bib[[i]]$url <- "URL not available"
      }
    }
  }
  return(bib)
}

# to check and replace URLs in the CSL file
namespace <- c(csl = "http://purl.org/net/xbiblio/csl")
check_csl_urls <- function(csl_file_path) {
  csl_doc <- XML::xmlParse(csl_file_path)
  link_nodes <- XML::xpathSApply(csl_doc, "//csl:link", XML::xmlGetAttr, "href", namespaces = namespace)
  for (i in seq_along(link_nodes)) {
    href <- link_nodes[i]
    if (!check_url_status(href)) {
      xpath_query <- paste("//csl:link[position()=", i, "]", sep = "")
      XML::xpathSApply(csl_doc, xpath_query, function(node) {
        XML::xmlAttrs(node)["href"] <- "URL not available"
      },namespaces = namespace)
    }
  }
  csl_doc
}

test_url <- function()
{
# Check URLs in the .bib file
  bib_file <- system.file("REFERENCES.bib",package="gaawr2")
  bib_updated <- check_bib_url_status(bib_file)
  bibtex::write.bib(bib_updated, file = "REFERENCES_updated.bib")

# Run URL check for CSL file
  csl_file <- system.file("csl","nature-genetics.csl",package="gaawr2")
  check_csl_urls(csl_file)
}

run_powerEQTL <- function()
{
  n.designs <- 6
  designs <- 1:n.designs
  N <- 50 * designs
  n.grids <- 100
  index <- 1:n.grids
  grids <- index / n.grids
  MAF <- seq(0.005, n.grids/2, by=0.5) / n.grids
  plot(MAF,grids,type="n",ylab="Power")
  mtext(expression(paste("(",alpha," = 0.05)")),1,line=4.5)
  colors <- grDevices::hcl.colors(n.designs)
  for (design in designs)
  {
    power.SLR <- rep(NA,n.grids)
    for (j in index) power.SLR[j] <- powerEQTL::powerEQTL.SLR(MAF = MAF[j], FWER = 0.05, nTests = 240, slope = 0.13,
                                                            n = N[design], sigma.y = 0.13)
    lines(MAF,power.SLR,col=colors[design])
  }
  legend("bottomright", inset=.02, title="Sample size (N)", paste(N), col=colors, horiz=FALSE, cex=0.8, lty=designs)
}

run_OpenTargets <- function()
{
  library(httr)
  library(jsonlite)
  library(knitr)
  library(kableExtra)

  gene_id <- "ENSG00000164308"
  query_string = "
    query target($ensemblId: String!){
      target(ensemblId: $ensemblId){
        id
        approvedSymbol
        biotype
        geneticConstraint {
          constraintType
          exp
          obs
          score
          oe
          oeLower
          oeUpper
        }
        tractability {
          label
          modality
          value
        }
      }
    }
  "
  base_url <- "https://api.platform.opentargets.org/api/v4/graphql"
  variables <- list("ensemblId" = gene_id)
  post_body <- list(query = query_string, variables = variables)
  r <- httr::POST(url=base_url, body=post_body, encode='json')
  data <- iconv(r, "", "ASCII")
  content <- jsonlite::fromJSON(data)
  target <- content$data$target
  scalar_fields <- data.frame(
    Field = c("ID", "Approved Symbol", "Biotype"),
    Value = c(target$id, target$approvedSymbol, target$biotype)
  )
  tractability_data <- target$tractability
  kableExtra::kbl(scalar_fields, caption = "(a) Basic Information") %>%
    kableExtra::kable_styling(bootstrap_options = c("striped", "hover"))
  kableExtra::kbl(target$geneticConstraint, caption = "(b) Genetic Constraint Metrics") %>%
    kableExtra::kable_styling(bootstrap_options = c("striped", "hover"))
  kableExtra::kbl(tractability_data, caption = "(c) Tractability Information") %>%
    kableExtra::kable_styling(bootstrap_options = c("striped", "hover"), full_width = FALSE)
}

run_h2.jags <- function()
{
  require(gap)
  set.seed(1234567)
  meyer <- within(meyer,{
           y[is.na(y)] <- rnorm(length(y[is.na(y)]),mean(y,na.rm=TRUE),sd(y,na.rm=TRUE))
           g1 <- ifelse(generation==1,1,0)
           g2 <- ifelse(generation==2,1,0)
           id <- animal
           animal <- ifelse(!is.na(animal),animal,0)
           dam <- ifelse(!is.na(dam),dam,0)
           sire <- ifelse(!is.na(sire),sire,0)
       })
  G <- kin.morgan(meyer)$kin.matrix*2
  library(regress)
  r <- regress(y~-1+g1+g2,~G,data=meyer)
  r
  with(r,h2G(sigma,sigma.cov))
  eps <- 0.001
  y <- with(meyer,y)
  x <- with(meyer,cbind(g1,g2))
  ex <- h2.jags(y,x,G,sigma.p=0.03,sigma.r=0.014)
  print(ex)
  require(coda)
  par(mfrow=c(2,2))
  ex.mcmc <- as.mcmc(ex)
  traceplot(ex.mcmc)
  densplot(ex.mcmc)
# only h2
  h2.samples <- ex.mcmc[,"h2"]
  png("h2.png",res=300,width=12,height=8,units="in")
  par(mfrow=c(1,2))
  traceplot(h2.samples,main="Traceplot of h2")
  densplot(h2.samples,main="Density plot of h2")
  dev.off()
}

library(httr)
library(jsonlite)

openai_token <- Sys.getenv("SUPERSECRET_OPENAI_TOKEN")
body <- list(
  model = "dall-e-3",
  prompt = "man in a classroom teaching physics, 18th century theme, clip-art style, print friendly",
  n = 1,
  size = "1024x1024"
)
response <- POST(
  url = "https://api.openai.com/v1/images/generations",
  httr::add_headers(
    "Content-Type" = "application/json",
    "Authorization" = paste("Bearer", openai_token)
  ),
  body = jsonlite::toJSON(body, auto_unbox = TRUE)
)

if (httr::status_code(response) == 200) {
  result <- httr::content(response, "parsed")
  print(result$data[[1]]$url)
} else {
  print(paste("Error:", httr::status_code(response)))
  print(httr::content(response, "text"))
}

create_gaawr2 <- function()
{
  library(usethis)
  create_package("gaawr2")
  use_mit_license()
  use_github_action("pkgdown", save_as = "R-CMD-check.yaml", ref = NULL, ignore = TRUE, open = FALSE)
  use_logo("pkgdown/logo.png")
# Image in README.Rmd
# <img src="man/figures/logo.png" align="right" height="86" alt="gaawr2 website" />
  library(pkgdown)
# https://realfavicongenerator.net/
# favicons
# build_favicons(overwrite=TRUE)
}

run_GMMAT <- function()
{
  library(GMMAT)
  data(example,package="GMMAT")
  attach(example)
  model0 <- GMMAT::glmmkin(disease ~ age + sex, data = pheno, kins = GRM,
                           id = "id", family = binomial(link = "logit"))
  model1 <- GMMAT::glmmkin(fixed = trait ~ age + sex, data = pheno, kins = GRM,
                           id = "id", family = gaussian(link = "identity"))
  model2 <- GMMAT::glmmkin(fixed = trait ~ age + sex, data = pheno, kins = GRM,
                           id = "id", groups = "disease",
                           family = gaussian(link = "identity"))
  snps <- c("SNP10", "SNP25", "SNP1", "SNP0")
  geno.file <- system.file("extdata", "geno.bgen", package = "GMMAT")
  samplefile <- system.file("extdata", "geno.sample", package = "GMMAT")
  outfile <- "glmm.score.txt"
  GMMAT::glmm.score(model0, infile = geno.file, BGEN.samplefile = samplefile,
                    outfile = outfile)
  read.delim(outfile) |>
       head(n=4) |>
       knitr::kable(caption="Score tests under GLMM on four SNPs",digits=2)
  unlink(outfile)
  bed.file <- system.file("extdata", "geno.bed", package = "GMMAT") |>
              tools::file_path_sans_ext()
  model.wald <- GMMAT::glmm.wald(fixed = disease ~ age + sex, data = pheno,
                                 kins = GRM, id = "id", family = binomial(link = "logit"),
                                 infile = bed.file, snps = snps)
  knitr::kable(model.wald,caption="Wald tests under GLMM on four SNPs")
  detach(example)
}

run_HardyWeinberg <- function()
{
  options.default <- options()
  options(width=200,digits=2)
# MN blood group
  SNP <- c(MM = 298, MN = 489, NN = 213)
  HardyWeinberg::maf(SNP)
  HardyWeinberg::HWTernaryPlot(SNP,region=0,hwcurve=FALSE,grid=TRUE,markercol="blue")
  HardyWeinberg::HWChisq(SNP, cc = 0, verbose = TRUE)
# png("MN.png",res=300,width=8,height=6,units="in")
# HardyWeinberg::HWTernaryPlot(SNP,region=0,hwcurve=FALSE,grid=TRUE,markercol="blue")
# dev.off()
# Chromosome X
  xSNP <- c(A=10, B=20, AA=30, AB=20, BB=10)
  HardyWeinberg::HWChisq(xSNP,cc=0,x.linked=TRUE,verbose=TRUE)
# HLA/DQR
  library(gap)
  DQR <- hla[,3:4]
  a1 <- DQR[1]
  a2 <- DQR[2]
  GenotypeCounts <- HardyWeinberg::AllelesToTriangular(a1,a2)
  knitr::kable(GenotypeCounts,caption="Genotype distribution of DQR")
  HardyWeinberg::HWPerm.mult(GenotypeCounts,nperm=1000)
  HardyWeinberg::HWStr(hla[,3:4],test="permutation",nperm=1000)
  options(options.default)
}

run_rentrez <- function()
{
  library(rentrez)
  entrez_dbs()
  entrez_db_links("pubmed")
  pubmed_fields <- entrez_db_searchable("pubmed")
# set_entrez_key("")
  Sys.getenv("ENTREZ_KEY")
  term <- "pQTLs OR (protein AND quantitative AND trait AND loci) AND human [MH] AND (plasma OR Serum)"
  r <- entrez_search(db="pubmed",term=term,use_history=TRUE)
  class(r)
  names(r)
  with(r,web_history)
  unlink(paste("pubmed",c("fetch","summary"),sep="."))
  fields <- c("uid", "pubdate", "sortfirstauthor", "title", "source", "volume", "pages")
  for(i in seq(1,with(r,count),50))
  {
    cat(i+49, "records downloaded\r")
    f <- entrez_fetch(db="pubmed", web_history=with(r,web_history), rettype="text", retmax=50, retstart=i)
    write.table(f, col.names=FALSE, row.names=FALSE, file="pubmed.fetch", append=TRUE)
    s <- entrez_summary(db="pubmed", web_history=with(r,web_history), rettype="text", retmax=50, retstart=i)
    e <- extract_from_esummary(s, fields)
    write.table(t(e), col.names=FALSE, row.names=FALSE, file="pubmed.summary", append=TRUE, sep="\t")
  }
  id <- 600807
  upload <- entrez_post(db="omim", id=id)
  asthma_variants <- entrez_link(dbfrom="omim", db="clinvar", cmd="neighbor_history", web_history=upload)
  asthma_variants
  snp_links <- entrez_link(dbfrom="clinvar", db="snp", web_history=asthma_variants$web_histories$omim_clinvar, cmd="neighbor_history")
  all_links <- entrez_link(dbfrom='pubmed', id=id, db='all')
}

use_ontologyIndex <- function()
{
  library(ontologyIndex)
  id <- function(ontology)
  {
    inflammatory <- grep(ontology$name,pattern="inflammatory")
    immune <- grep(ontology$name,pattern="immune")
    inf <- union(inflammatory,immune)
    list(id=ontology$id[inf],name=ontology$name[inf])
  }
# GO
  data(go)
  goidname <- id(go)
# EFO
  file <- "efo.obo" # efo-3.26.0
  get_relation_names(file)
  efo <- get_ontology(file, extract_tags="everything")
  length(efo) # 89
  length(efo$id) # 27962
  efoidname <- id(efo)
  diseases <- get_descendants(efo,"EFO:0000408")
  efo_0000540 <- get_descendants(efo,"EFO:0000540")
  efo_0000540name <- efo$name[efo_0000540]
  isd <- data.frame(efo_0000540,efo_0000540name)
  save(efo,diseases,isd,efoidname,goidname, file="efo.rda")
  write.table(isd,file="efo_0000540.csv",col.names=FALSE,row.names=FALSE,sep=",")
  library(ontologyPlot)
  onto_plot(efo,efo_0000540)
}

use_biomaRt <- function()
{
  library(biomaRt)
  if (!biomaRt::martBMCheck(mart)) {
    stop("The BioMart service is currently unavailable.")
  }
  biomaRt::listMarts()
  ensembl <- biomaRt::useMart("ensembl", dataset="hsapiens_gene_ensembl", host="grch37.ensembl.org", path="/biomart/martservice")
  biomaRt::listDatasets(ensembl)
  attr <- biomaRt::listAttributes(ensembl)
  attr_select <- c('ensembl_gene_id', 'chromosome_name', 'start_position', 'end_position', 'description', 'hgnc_symbol',
                   'transcription_start_site')
  gene <- biomaRt::getBM(attributes = attr_select, mart = ensembl)
  filter <- biomaRt::listFilters(ensembl)
  biomaRt::searchFilters(mart = ensembl, pattern = "gene")
# GRCh38
  ensembl <- biomaRt::useMart("ensembl", dataset="hsapiens_gene_ensembl")
}

use_locuszoomr <- function()
{
  require(locuszoomr)
  require(EnsDb.Hsapiens.v75)

  data(SLE_gwas_sub,package="locuszoomr")
  head(SLE_gwas_sub)
  loc <- locuszoomr::locus(data = SLE_gwas_sub, gene = 'UBE2L3', flank = 1e5,
                           ens_db = "EnsDb.Hsapiens.v75")
  loc <- locuszoomr::link_LD(loc, token = Sys.getenv("LDLINK_TOKEN"))
  summary(loc)
  locuszoomr::locus_plot(loc)
  locuszoomr::locus_plot(loc, filter_gene_biotype = "protein_coding")
  locuszoomr::locus_plot(loc, filter_gene_name = c('UBE2L3', 'RIMBP3C', 'YDJC', 'PPIL2',
                                                   'PI4KAP2', 'MIR301B'))
  loc2 <- locuszoomr::locus(SLE_gwas_sub, gene = 'IRF5', flank = c(7e4, 2e5), LD = "r2",
                            ens_db = "EnsDb.Hsapiens.v75")
  require(rtracklayer)
  bw38 <- "https://hgdownload.soe.ucsc.edu/gbdb/hg38/recombRate/recomb1000GAvg.bw"
  bw19 <- "https://hgdownload.soe.ucsc.edu/gbdb/hg19/decode/hapMapRelease24CombinedRecombMap.bw"
  download.file(bw19, destfile = basename(bw19))
  recomb.hg19 <- rtracklayer::import.bw(basename(bw19))
  unlink(basename(bw19))
  loc3 <- locuszoomr::locus(SLE_gwas_sub, gene = 'STAT4', flank = 1e5, LD = "r2",
                            ens_db = "EnsDb.Hsapiens.v75")
  loc3 <- locuszoomr::link_recomb(loc3, recomb = recomb.hg19)
  locuszoomr::locus_plot(loc3)

  p1 <- locuszoomr::locus_ggplot(loc, labels = "index", nudge_x = 0.03)
  p2 <- locuszoomr::locus_ggplot(loc2, legend_pos = NULL)

  library(cowplot)
  cowplot::plot_grid(p1, p2, ncol = 1)

  library(ggpubr)
  ggpubr::ggarrange(p1, p2, ncol = 1)

  library(gridExtra)
  gridExtra::grid.arrange(p1, p2, ncol = 1)

  locuszoomr::locus_ggplot(loc)
  locuszoomr::gg_scatter(loc)
  locuszoomr::gg_genetracks(loc)
  p <- locuszoomr::gg_scatter(loc)
  locuszoomr::gg_addgenes(p, loc)
  locuszoomr::locus_plotly(loc)

  locuszoomr::multi_layout(ncol = 3,
               plots = {
                 locuszoomr::locus_plot(loc, use_layout = FALSE, legend_pos = 'topleft')
                 locuszoomr::locus_plot(loc2, use_layout = FALSE, legend_pos = NULL)
                 locuszoomr::locus_plot(loc3, use_layout = FALSE, legend_pos = NULL, labels = "index")
               })
}

#!/usr/bin/bash

function setup()
{
Rscript -e '
  suppressMessages(library(pkgdown))
  {
    knitr::knit("README.Rmd")
    roxygen2::roxygenise()
    pkgdown::build_favicons(overwrite=TRUE)
    pkgdown::build_site()
  }
  pkgdown::build_site_github_pages()
# clean_site(); init_site(); build_home(); build_news(); build_articles(); build_reference(); build_search()
'
# devtools::build_rmd() is equivalent but limited, so knitr::knit/pandoc are better options.
# pandoc README.md --citeproc --mathjax -s --self-contained -o index.html
}

# setup

module load ceuadmin/R
module load gcc/11.3.0/gcc/4zpip55j

Rscript -e '
# rmarkdown::render("pkgdown/index.Rmd", output_format = "md_document");
  knitr::knit("README.Rmd");devtools::document();pkgdown::build_site()
'

rm -f vignettes/.RData vignettes/.Rhistory
for d in gaawr2 web
do
    if [ -d vignettes/${d} ]; then
       rm -rf docs/articles/${d}
       mv vignettes/${d} docs/articles/
    fi
done

for f in .github .gitignore .Rbuildignore .Rinstignore $(ls)
do
  echo adding ${f}
  git add ${f}
  git commit -m "${f}"
done
git push --set-upstream origin main
du -h --exclude .git --exclude docs

#!/usr/bin/bash

module load ceuadmin/htslib
export csd3_inf1=~/rds/results/private/proteomics/scallop-inf1/METAL
export f=${csd3_inf1}/IL.18R1-1.tbl.gz
export r=2:102700000-103800000

(
  gunzip -c ${f} | \
  head -1
  tabix ${f} ${r}
) | \
bgzip -f > IL.18R1-1.tbl.gz
tabix -f -S1 -s1 -b2 -e2 IL.18R1-1.tbl.gz

export gcst_inf1=https://ftp.ebi.ac.uk/pub/databases/gwas/summary_statistics/GCST90274001-GCST90275000/
export gcst=${gcst_inf1}/GCST90274804/harmonised/GCST90274804.h.tsv.gz
(
  wget -qO- ${gcst} | \
  gunzip -c | \
  head -1
  tabix ${gcst} ${r}
) | \
bgzip -f > IL.18R1.gz
tabix -f -S1 -s1 -b2 -e2 IL.18R1.gz
rm GCST90274804.h.tsv.gz.tbi

Rscript -e '
suppressMessages(library(dplyr))
r <- Sys.getenv("r")
d <- read.delim(file.path("tests","IL.18R1-1.tbl.gz"))
metal <- TwoSampleMR::format_data(within(d,{P=10^log.P.}), phenotype_col="prot", snp_col="MarkerName",
                      chr_col="Chromosome", pos_col="Posistion",
                      effect_allele_col="Allele1", other_allele_col="Allele2",
                      eaf_col="Freq1", beta_col="Effect", se_col="StdErr",
                      pval_col="P", log_pval=FALSE,
                      samplesize_col="N")
gcst <- TwoSampleMR::format_data(read.delim(file.path("tests","IL.18R1.gz")),
                     chr_col="chromosome", pos_col="base_pair_location", snp_col="rsid",
                     effect_allele_col="effect_allele", other_allele_col="other_allele",
                     eaf_col="effect_allele_frequency", beta_col="beta", se_col="standard_error",
                     pval_col="p_value", log_pval=FALSE,
                     samplesize_col="n")
outcome <- pQTLtools::import_OpenGWAS("ebi−a−GCST004132",r,"gwasvcf") %>%
           as.data.frame() %>%
           dplyr::mutate(outcome="Crohns disease",LP=10^-LP) %>%
           dplyr::select(ID,outcome,REF,ALT,AF,ES,SE,LP,SS,id) %>%
           setNames(c("SNP","outcome",paste0(c("other_allele","effect_allele","eaf","beta","se","pval","samplesize","id"),".outcome")))
clump <- TwoSampleMR::clump_data(gcst)
harmonise <- TwoSampleMR::harmonise_data(clump,outcome)
prefix <- paste("IL.18R1,"cis",sep="-")
pQTLtools::run_TwoSampleMR(harmonise, mr_plot="pQTLtools", prefix=prefix)
`
# https://jinghuazhao.github.io/INF/doc/GWAS-INF.pdf
# Eczema(ieu−a−996)

#!/usr/bin/bash

function create_github_repository()
{
  export user=jinghuazhao
  export token=$(awk "NR==2" ~/doc/access)
  export API=https://api.github.com
  export header="Accept: application/vnd.github.v3+json"
  export name=gaawr2

# 1. create the repository
  curl -X POST -u $user:$token -H "$header" -d '{"name": "'"$name"'"}' $API/user/repos

# 2. list the repository
  curl -H "$header" $API/repos/$user/$name

# 3. delete the repository
# curl -X DELETE -u $user:$token -H "$header" $API/repos/$user/$name

# 4. customise settings and commit
  git config --global user.email "jinghuazhao@hotmail.com"
  git config --global user.name "jinghuazhao@github.com"
  git config --global url."https://jinghuazhao@github.com".insteadOf "https://github.com"
  git init
  git branch -M main
  git remote add origin git@github.com:jinghuazhao/gaawr2.git
  git commit --allow-empty -m "Initial commit"
  git push --set-upstream origin main
}

create_github_repository

#!/usr/bin/bash

# convert -density 300 logo.svg logo.png
# https://www.freeconvert.com/image-converter

Rscript -e '
      knitr::knit("README.Rmd")
      library(pkgdown)
    # init_site()
    # roxygen2::roxygenise()
      devtools::document()
      build_site()
  '

---
title: " "
output:
  bookdown::html_document2:
    toc: true
    toc_float: true
    number_sections: true
    self_contained: false
pkgdown:
  as_is: true
vignette: >
  %\VignetteIndexEntry{Web facilities}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r gaawr2_incl, echo=FALSE, results='asis'}
htmltools::tags$iframe(
  src = "https://jinghuazhao.github.io/R/vignettes/web.html",
  width = "100%",
  style = "height:100vh; border:none;"
)
```

---
title: "CSL URL Checking and Citation Example"
author: "ChatGPT"
output: html_document
bibliography: '`r system.file("REFERENCES.bib", package="gaawr2")`'
csl: !r csl_content
vignette: >
  %\VignetteIndexEntry{gaawr2}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
  %\VignetteDepends{httr, XML}
---

```{r setup, warning=FALSE}
source(system.file("csl","url.R",package="gaawr2"))
csl_file_path <- "nature-genetics.csl"
csl_file_path <- system.file("csl",csl_file_path,package="gaawr2")

cat("CSL File Content (Raw):\n")
cat(paste(readLines(csl_file_path), collapse = "\n"))

cat("\nExtracted Links from CSL File:\n")
csl_doc <- check_csl_urls(csl_file_path)
hrefs <- xpathSApply(csl_doc, "//csl:link", xmlGetAttr, "href", namespaces = namespace)
print(hrefs)
```

Would this work @malone10?

## References
